diff --git a/target/linux/ipq40xx/files-4.19/arch/arm/boot/dts/qcom-ipq4018-dap-2610.dts b/target/linux/ipq40xx/files-4.19/arch/arm/boot/dts/qcom-ipq4018-dap-2610.dts
index 0fd4318527..17d9215544 100644
--- a/target/linux/ipq40xx/files-4.19/arch/arm/boot/dts/qcom-ipq4018-dap-2610.dts
+++ b/target/linux/ipq40xx/files-4.19/arch/arm/boot/dts/qcom-ipq4018-dap-2610.dts
@@ -19,7 +19,7 @@
 	soc {
 		edma@c080000 {
 			qcom,num_gmac = <1>;
-			status = "ok";
+			status = "okay";
 		};
 
 		tcsr@1949000 {
@@ -41,25 +41,25 @@
 		};
 
 		rng@22000 {
-			status = "ok";
+			status = "okay";
 		};
 
 		crypto@8e3a000 {
-			status = "ok";
+			status = "okay";
 		};
 
 		watchdog@b017000 {
-			status = "ok";
+			status = "okay";
 		};
 
 		ess-switch@c000000 {
-			status = "ok";
+			status = "okay";
 			switch_lan_bmp = <0x20>;
 			switch_wan_bmp = <0x00>;
 		};
 
 		ess-psgmii@98000 {
-			status = "ok";
+			status = "okay";
 		};
 	};
 
@@ -91,7 +91,7 @@
 &blsp1_spi1 {
 	pinctrl-0 = <&spi_0_pins>;
 	pinctrl-names = "default";
-	status = "ok";
+	status = "okay";
 	cs-gpios = <&tlmm 54 GPIO_ACTIVE_HIGH>;
 
 	flash@0 {
@@ -179,17 +179,17 @@
 };
 
 &blsp_dma {
-	status = "ok";
+	status = "okay";
 };
 
 &blsp1_uart1 {
 	pinctrl-0 = <&serial_pins>;
 	pinctrl-names = "default";
-	status = "ok";
+	status = "okay";
 };
 
 &cryptobam {
-	status = "ok";
+	status = "okay";
 };
 
 &gmac0 {
@@ -201,7 +201,7 @@
 };
 
 &mdio {
-	status = "ok";
+	status = "okay";
 };
 
 &tlmm {
@@ -231,11 +231,11 @@
 };
 
 &wifi0 {
-	status = "ok";
+	status = "okay";
 	qcom,ath10k-calibration-variant = "dlink,dap-2610";
 };
 
 &wifi1 {
-	status = "ok";
+	status = "okay";
 	qcom,ath10k-calibration-variant = "dlink,dap-2610";
 };
diff --git a/target/linux/ipq40xx/files-4.19/arch/arm/boot/dts/qcom-ipq4019-wpj419.dts b/target/linux/ipq40xx/files-4.19/arch/arm/boot/dts/qcom-ipq4019-wpj419.dts
index 6cf9d46767..3a0e0b8cfa 100644
--- a/target/linux/ipq40xx/files-4.19/arch/arm/boot/dts/qcom-ipq4019-wpj419.dts
+++ b/target/linux/ipq40xx/files-4.19/arch/arm/boot/dts/qcom-ipq4019-wpj419.dts
@@ -275,7 +275,7 @@
 		i2c_0: i2c@78b7000 {
 			pinctrl-0 = <&i2c_0_pins>;
 			pinctrl-names = "default";
-			status = "ok";
+			status = "okay";
 		};
 
 		serial@78af000 {
diff --git a/target/linux/ipq40xx/files-4.19/arch/arm/boot/dts/qcom-ipq4029-ap-303.dts b/target/linux/ipq40xx/files-4.19/arch/arm/boot/dts/qcom-ipq4029-ap-303.dts
index 24e5dc2809..bc4fd9eb17 100644
--- a/target/linux/ipq40xx/files-4.19/arch/arm/boot/dts/qcom-ipq4029-ap-303.dts
+++ b/target/linux/ipq40xx/files-4.19/arch/arm/boot/dts/qcom-ipq4029-ap-303.dts
@@ -88,7 +88,7 @@
 		i2c_0: i2c@78b7000 {
 			pinctrl-0 = <&i2c_0_pins>;
 			pinctrl-names = "default";
-			status = "ok";
+			status = "okay";
 
 			tpm@29 {
 				/* No Driver */
diff --git a/target/linux/ipq40xx/files-4.19/arch/arm/boot/dts/qcom-ipq4029-ap-303h.dts b/target/linux/ipq40xx/files-4.19/arch/arm/boot/dts/qcom-ipq4029-ap-303h.dts
index 0859f97c9e..1f7a728492 100644
--- a/target/linux/ipq40xx/files-4.19/arch/arm/boot/dts/qcom-ipq4029-ap-303h.dts
+++ b/target/linux/ipq40xx/files-4.19/arch/arm/boot/dts/qcom-ipq4029-ap-303h.dts
@@ -87,7 +87,7 @@
 		i2c_0: i2c@78b7000 {
 			pinctrl-0 = <&i2c_0_pins>;
 			pinctrl-names = "default";
-			status = "ok";
+			status = "okay";
 
 			tpm@29 {
 				/* No Driver */
diff --git a/target/linux/ipq40xx/files-5.4/arch/arm/boot/dts/qcom-ipq4018-dap-2610.dts b/target/linux/ipq40xx/files-5.4/arch/arm/boot/dts/qcom-ipq4018-dap-2610.dts
index 0fd4318527..17d9215544 100644
--- a/target/linux/ipq40xx/files-5.4/arch/arm/boot/dts/qcom-ipq4018-dap-2610.dts
+++ b/target/linux/ipq40xx/files-5.4/arch/arm/boot/dts/qcom-ipq4018-dap-2610.dts
@@ -19,7 +19,7 @@
 	soc {
 		edma@c080000 {
 			qcom,num_gmac = <1>;
-			status = "ok";
+			status = "okay";
 		};
 
 		tcsr@1949000 {
@@ -41,25 +41,25 @@
 		};
 
 		rng@22000 {
-			status = "ok";
+			status = "okay";
 		};
 
 		crypto@8e3a000 {
-			status = "ok";
+			status = "okay";
 		};
 
 		watchdog@b017000 {
-			status = "ok";
+			status = "okay";
 		};
 
 		ess-switch@c000000 {
-			status = "ok";
+			status = "okay";
 			switch_lan_bmp = <0x20>;
 			switch_wan_bmp = <0x00>;
 		};
 
 		ess-psgmii@98000 {
-			status = "ok";
+			status = "okay";
 		};
 	};
 
@@ -91,7 +91,7 @@
 &blsp1_spi1 {
 	pinctrl-0 = <&spi_0_pins>;
 	pinctrl-names = "default";
-	status = "ok";
+	status = "okay";
 	cs-gpios = <&tlmm 54 GPIO_ACTIVE_HIGH>;
 
 	flash@0 {
@@ -179,17 +179,17 @@
 };
 
 &blsp_dma {
-	status = "ok";
+	status = "okay";
 };
 
 &blsp1_uart1 {
 	pinctrl-0 = <&serial_pins>;
 	pinctrl-names = "default";
-	status = "ok";
+	status = "okay";
 };
 
 &cryptobam {
-	status = "ok";
+	status = "okay";
 };
 
 &gmac0 {
@@ -201,7 +201,7 @@
 };
 
 &mdio {
-	status = "ok";
+	status = "okay";
 };
 
 &tlmm {
@@ -231,11 +231,11 @@
 };
 
 &wifi0 {
-	status = "ok";
+	status = "okay";
 	qcom,ath10k-calibration-variant = "dlink,dap-2610";
 };
 
 &wifi1 {
-	status = "ok";
+	status = "okay";
 	qcom,ath10k-calibration-variant = "dlink,dap-2610";
 };
diff --git a/target/linux/ipq40xx/files-5.4/arch/arm/boot/dts/qcom-ipq4019-wpj419.dts b/target/linux/ipq40xx/files-5.4/arch/arm/boot/dts/qcom-ipq4019-wpj419.dts
index 6cf9d46767..3a0e0b8cfa 100644
--- a/target/linux/ipq40xx/files-5.4/arch/arm/boot/dts/qcom-ipq4019-wpj419.dts
+++ b/target/linux/ipq40xx/files-5.4/arch/arm/boot/dts/qcom-ipq4019-wpj419.dts
@@ -275,7 +275,7 @@
 		i2c_0: i2c@78b7000 {
 			pinctrl-0 = <&i2c_0_pins>;
 			pinctrl-names = "default";
-			status = "ok";
+			status = "okay";
 		};
 
 		serial@78af000 {
diff --git a/target/linux/ipq40xx/files-5.4/arch/arm/boot/dts/qcom-ipq4029-ap-303.dts b/target/linux/ipq40xx/files-5.4/arch/arm/boot/dts/qcom-ipq4029-ap-303.dts
index 24e5dc2809..bc4fd9eb17 100644
--- a/target/linux/ipq40xx/files-5.4/arch/arm/boot/dts/qcom-ipq4029-ap-303.dts
+++ b/target/linux/ipq40xx/files-5.4/arch/arm/boot/dts/qcom-ipq4029-ap-303.dts
@@ -88,7 +88,7 @@
 		i2c_0: i2c@78b7000 {
 			pinctrl-0 = <&i2c_0_pins>;
 			pinctrl-names = "default";
-			status = "ok";
+			status = "okay";
 
 			tpm@29 {
 				/* No Driver */
diff --git a/target/linux/ipq40xx/files-5.4/arch/arm/boot/dts/qcom-ipq4029-ap-303h.dts b/target/linux/ipq40xx/files-5.4/arch/arm/boot/dts/qcom-ipq4029-ap-303h.dts
index 0859f97c9e..1f7a728492 100644
--- a/target/linux/ipq40xx/files-5.4/arch/arm/boot/dts/qcom-ipq4029-ap-303h.dts
+++ b/target/linux/ipq40xx/files-5.4/arch/arm/boot/dts/qcom-ipq4029-ap-303h.dts
@@ -87,7 +87,7 @@
 		i2c_0: i2c@78b7000 {
 			pinctrl-0 = <&i2c_0_pins>;
 			pinctrl-names = "default";
-			status = "ok";
+			status = "okay";
 
 			tpm@29 {
 				/* No Driver */
diff --git a/target/linux/ipq40xx/patches-4.19/077-qcom-ipq4019-add-USB-devicetree-nodes.patch b/target/linux/ipq40xx/patches-4.19/077-qcom-ipq4019-add-USB-devicetree-nodes.patch
index e02fdf59c2..30a0678fd8 100644
--- a/target/linux/ipq40xx/patches-4.19/077-qcom-ipq4019-add-USB-devicetree-nodes.patch
+++ b/target/linux/ipq40xx/patches-4.19/077-qcom-ipq4019-add-USB-devicetree-nodes.patch
@@ -19,23 +19,23 @@ Signed-off-by: John Crispin <john@phrozen.org>
  		};
 +
 +		usb3_ss_phy: ssphy@9a000 {
-+			status = "ok";
++			status = "okay";
 +		};
 +
 +		usb3_hs_phy: hsphy@a6000 {
-+			status = "ok";
++			status = "okay";
 +		};
 +
 +		usb3: usb3@8af8800 {
-+			status = "ok";
++			status = "okay";
 +		};
 +
 +		usb2_hs_phy: hsphy@a8000 {
-+			status = "ok";
++			status = "okay";
 +		};
 +
 +		usb2: usb2@60f8800 {
-+			status = "ok";
++			status = "okay";
 +		};
  	};
  };
diff --git a/target/linux/ipq40xx/patches-4.19/900-dts-ipq4019-ap-dk01.1.patch b/target/linux/ipq40xx/patches-4.19/900-dts-ipq4019-ap-dk01.1.patch
index 48825375eb..5157079762 100644
--- a/target/linux/ipq40xx/patches-4.19/900-dts-ipq4019-ap-dk01.1.patch
+++ b/target/linux/ipq40xx/patches-4.19/900-dts-ipq4019-ap-dk01.1.patch
@@ -17,7 +17,7 @@
 +			compatible = "qcom,tcsr";
 +			reg = <0x194b000 0x100>;
 +			qcom,usb-hsphy-mode-select = <TCSR_USB_HSPHY_HOST_MODE>;
-+			status = "ok";
++			status = "okay";
 +		};
 +
 +		ess_tcsr@1953000 {
@@ -77,7 +77,7 @@
 +		};
 +
  		usb3_ss_phy: ssphy@9a000 {
- 			status = "ok";
+ 			status = "okay";
  		};
 --- a/arch/arm/boot/dts/qcom-ipq4019-ap.dk01.1-c1.dts
 +++ b/arch/arm/boot/dts/qcom-ipq4019-ap.dk01.1-c1.dts
diff --git a/target/linux/ipq40xx/patches-5.4/077-qcom-ipq4019-add-USB-devicetree-nodes.patch b/target/linux/ipq40xx/patches-5.4/077-qcom-ipq4019-add-USB-devicetree-nodes.patch
index fbcbecf080..5efc08bcca 100644
--- a/target/linux/ipq40xx/patches-5.4/077-qcom-ipq4019-add-USB-devicetree-nodes.patch
+++ b/target/linux/ipq40xx/patches-5.4/077-qcom-ipq4019-add-USB-devicetree-nodes.patch
@@ -19,23 +19,23 @@ Signed-off-by: John Crispin <john@phrozen.org>
  		};
 +
 +		usb3_ss_phy: ssphy@9a000 {
-+			status = "ok";
++			status = "okay";
 +		};
 +
 +		usb3_hs_phy: hsphy@a6000 {
-+			status = "ok";
++			status = "okay";
 +		};
 +
 +		usb3: usb3@8af8800 {
-+			status = "ok";
++			status = "okay";
 +		};
 +
 +		usb2_hs_phy: hsphy@a8000 {
-+			status = "ok";
++			status = "okay";
 +		};
 +
 +		usb2: usb2@60f8800 {
-+			status = "ok";
++			status = "okay";
 +		};
  	};
  };
diff --git a/target/linux/ipq40xx/patches-5.4/900-dts-ipq4019-ap-dk01.1.patch b/target/linux/ipq40xx/patches-5.4/900-dts-ipq4019-ap-dk01.1.patch
index 48825375eb..5157079762 100644
--- a/target/linux/ipq40xx/patches-5.4/900-dts-ipq4019-ap-dk01.1.patch
+++ b/target/linux/ipq40xx/patches-5.4/900-dts-ipq4019-ap-dk01.1.patch
@@ -17,7 +17,7 @@
 +			compatible = "qcom,tcsr";
 +			reg = <0x194b000 0x100>;
 +			qcom,usb-hsphy-mode-select = <TCSR_USB_HSPHY_HOST_MODE>;
-+			status = "ok";
++			status = "okay";
 +		};
 +
 +		ess_tcsr@1953000 {
@@ -77,7 +77,7 @@
 +		};
 +
  		usb3_ss_phy: ssphy@9a000 {
- 			status = "ok";
+ 			status = "okay";
  		};
 --- a/arch/arm/boot/dts/qcom-ipq4019-ap.dk01.1-c1.dts
 +++ b/arch/arm/boot/dts/qcom-ipq4019-ap.dk01.1-c1.dts